routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
|run cmd
|php artisan make:auth
|php artisan migrate
|php artisan db:seed --class=PermissionTableSeeder
|php artisan db:seed --class=CreateAdminUserSeeder
|
|
*/
// Route test
// Route::get('/', function () {
//     return view('layouts.frontend');
// });

Route::get('/', 'FrontEndController@home');
Route::get('/sport','FrontEndController@sport');
Route::get('/sport-detail','FrontEndController@sportDetail');
Route::get('/technology','FrontEndController@technology');
Route::get('/technology-detail','FrontEndController@technologyDetail');
Route::get('/life','FrontEndController@life');
Route::get('/life-detail','FrontEndController@lifeDetail');
Route::get('/healthy-life','FrontEndController@healthyLife');
Route::get('/healthy-life-detail','FrontEndController@healthyLifeDetail');
Route::get('/entertainment','FrontEndController@entertainment');
Route::get('/entertainment-detail','FrontEndController@entertainmentDetail');
Route::get('/hang-out','FrontEndController@hangOut');
Route::get('/hang-out-detail','FrontEndController@hangOutDetail');

Route::get('/about', 'FrontEndController@about');
Route::get('/contact', 'FrontEndController@contact');

Auth::routes([
    'register' => false,
    'reset' => false,
    'verify' => false,
  ]);

Route::get('/home', 'HomeController@index')->name('home');

Route::group(['middleware' => ['auth']], function() {    

    Route::resource('article', 'ArticleController');
    Route::post('article/status/{id}', 'ArticleController@status');
    Route::resource('articletype', 'ArticleTypeController');
    Route::post('articletype/status/{id}', 'ArticleTypeController@status');
    Route::resource('user','UserController');
    Route::resource('role' , 'RoleController');

    // Configuration
    Route::get('configuration', 'ConfigurationController@index');

     //Clear route cache:
    Route::get('/clear-route-cache', function() {
        $exitCode = Artisan::call('route:cache');
        return back()->with('success','You has been clearred route successfully');
    });

    //Clear config cache:
    Route::get('/clear-cache-config', function() {
        $exitCode = Artisan::call('config:cache');
        return back()->with('success','You has been clearred config successfully');
    }); 

    // Clear application cache:
    Route::get('/clear-cache', function() {
        $exitCode = Artisan::call('cache:clear');
        return back()->with('success','You has been clearred cache successfully');
    });

    // Clear view cache:
    Route::get('/clear-view', function() {
        $exitCode = Artisan::call('view:clear');
        return back()->with('success','You has been clearred view successfully');
    });
});

Route::get('addlog', 'HomeController@addLog');
Route::get('logactivity', 'HomeController@logActivity');

//Multiple role & permission
//https://www.itsolutionstuff.com/post/laravel-58-user-roles-and-permissions-tutorialexample.html

app/Article.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Article extends Model
{
    protected $fillable = [
        'title', 'content','short_description', 'thumbnail', 'articletype_id','date','time','postby','active_status'
    ];
}

app/ArticleType.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class ArticleType extends Model
{
    protected $fillable = [
        'code', 'article_type', 'description', 'active_status'
    ];
}

app/Http/Controllers/ArticleController.php
<?php

namespace App\Http\Controllers;
use File;
use App\User;
use App\Article;
use App\ArticleType;
use App\Helpers\LogActivity;
use Illuminate\Http\Request;
use Spatie\Permission\Models\Role;
use Spatie\Permission\Models\Permission;
use Illuminate\Support\Facades\Storage;
use Intervention\Image\Facades\Image;
use Illuminate\Foundation\Auth\AuthenticatesUsers;

class ArticleController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    function __construct()
    {
         $this->middleware('permission:article-list|articles-create|article-edit|article-delete', ['only' => ['index','show']]);
         $this->middleware('permission:article-create', ['only' => ['create','store']]);
         $this->middleware('permission:article-edit', ['only' => ['edit','update']]);
         $this->middleware('permission:article-delete', ['only' => ['destroy']]);
    }

    public function index()
    {
        $articles = Article::orderBy('id', 'desc')
               ->get();
        return view('backend.articles.index',compact('articles'));
    }


    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $articleTypes = ArticleType::where('active_status', '=',"1")->orderBy('id','DESC')->get();
        return view('backend.articles.create',compact('articleTypes'));
    }


    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        request()->validate([
            'title' => 'required',
            'content' => 'required',
            'thumbnail'  =>  'required|file|image|mimes:jpeg,png,gif,jpg|max:2048'
        ]);    
        //$clientIP = \Request::getClientIp(true);        
        $title = $request->title;
        $detail= $request->content;
        
        $message=$request->content;
        $dom = new \DomDocument();
        $dom->loadHtml('<?xml encoding="UTF-8">'.$message);   
        $images = $dom->getElementsByTagName('img');

        foreach($images as $img){
            $src = $img->getAttribute('src');            
            // if the img source is 'data-url'
            if (preg_match("'/data:image/'", $src)) {
                preg_match("'/data:image\/(?<mime>.*?)\;/'", $src, $groups);
                $mimeType = $groups['mime'];
                $path = "'/images/'" . uniqid('', true) . '.' . $mimeType;
                Storage::disk('public')->put($path, file_get_contents($src));
                $image->removeAttribute('src');
                $image->setAttribute('src', Storage::disk('public')->url($path));
            }
        }

        // if ($request->file('thumbnail')->isValid()) {
        //     $file = $request->file('thumbnail');
        //     $fileName = 'thumbnail_'.uniqid().'.'.$file->getClientOriginalExtension();
        //     $pathImage = $file->storeAs('thumbnail', $fileName);
        // }
        $cover = $request->file('thumbnail');
        $covername = uniqid().'_thumbnail' .'.jpg';

        //if have an cover file
        if($cover){
            //storage the file on my public_covers (look my filesystems.php)
            Storage::disk('public')->put($covername, File::get($cover));
        }


        //
        $content = $dom->saveHTML();
        LogActivity::addLog('Create article: '.$title);

        Article::create([
            'title' => $title,
            'content' =>  $content,
            'short_description' => $request->short_description,
            'thumbnail' => $covername,
            'articletype_id' => $request->articletype,
            'date' => $request->date,
            'time' => $request->time,
            'postby' => "m",
            'active_status' => "1"
        ]);
        
        return redirect()->route('article.index')
                        ->with('success','Article has been created successfully.');
    
    }


    /**
     * Display the specified resource.
     *
     * @param  \App\Article  $article
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $articles = Article::find($id);
        $articleTypes = ArticleType::whereIn('id', array($articles->articletype_id))->first();
        return view('backend.articles.show',compact('articles','articleTypes'));
    }


    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Article  $article
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $articleTypes = ArticleType::where('active_status', '=',"1")->orderBy('id','DESC')->get();
        $articles = Article::find($id);
        return view('backend.articles.edit',compact('articleTypes','articles'));
    }


    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request,$id)
    {
        request()->validate([
            'title' => 'required',
            'content' => 'required',
            'thumbnail'  =>  'required|file|image|mimes:jpeg,png,gif,jpg|max:2048'
        ]);      
        $title = $request->title;
        $detail= $request->content;
        
        $message=$request->content;
        $dom = new \DomDocument();
        $dom->loadHtml('<?xml encoding="UTF-8">'.$message);   
        $images = $dom->getElementsByTagName('img');

        foreach($images as $img){
            $src = $img->getAttribute('src');        
            if (preg_match("'/data:image/'", $src)) {
                preg_match("'/data:image\/(?<mime>.*?)\;/'", $src, $groups);
                $mimeType = $groups['mime'];
                $path = "'/images/'" . uniqid('', true) . '.' . $mimeType;
                Storage::disk('public')->put($path, file_get_contents($src));
                $image->removeAttribute('src');
                $image->setAttribute('src', Storage::disk('public')->url($path));
            }
        }

        $cover = $request->file('thumbnail');
        $covername = uniqid().'_thumbnail' .'.jpg';

        if($cover){
            Storage::disk('public')->put($covername, File::get($cover));
        }

        $content = $dom->saveHTML();
        LogActivity::addLog('Update article: '.$title);

        $input = $request->all();

        $user = Article::find($id);
        $user->update($input); 

        // Article::create([
        //     'title' => $title,
        //     'content' =>  $content,
        //     'short_description' => $request->short_description,
        //     'thumbnail' => $covername,
        //     'articletype_id' => $request->articletype,
        //     'date' => $request->date,
        //     'time' => $request->time,
        //     'postby' => "m",
        //     'active_status' => "1"
        // ]);
        
        return redirect()->route('article.index')
                        ->with('success','Article has been updated successfully.');
    
    }


    public function status(Request $request,$id){
        Article::where('id', $id)->update(array(
            'active_status' 	  =>  $request->status
        ));
        return redirect()->route('article.index')
        ->with('success','Article has been updated (status) successfully.');

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        Article::find($id)->delete();
        return redirect()->route('article.index')
                        ->with('success','Article has been deleted successfully');
    }

    /**
     * Create a thumbnail of specified size
     *
     * @param string $path path of thumbnail
     * @param int $width
     * @param int $height
     */
   
  
}

resources/views/backend/articles/create.blade.php
@extends('layouts.backend') @section('css')
<style>
    .note-editable,.card-block{
    		height: 300px !important;;
    	}
</style>
@endsection @section('content')

<!-- Content Wrapper. Contains page content -->
<div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
        <div class="container-fluid">
            <div class="row mb-2">
                <div class="col-sm-6">
                    <h1>Dashboard</h1>
                </div>
                <div class="col-sm-6">
                    <ol class="breadcrumb float-sm-right">
                        <li class="breadcrumb-item">
                            <a href="#">Home</a>
                        </li>
                        <li class="breadcrumb-item">
                            <a href="{{ url('article') }}">Article</a>
                        </li>
                        <li class="breadcrumb-item active">Create Article</li>
                    </ol>
                </div>
            </div>
        </div>
        <!-- /.container-fluid -->
    </section>

    <!-- Main content -->

    <section class="content">
        <div class="container-fluid">
            <div class="row">
                <div class="col-12">
                    <div class="card card-outline card-info">
                        <div class="card-header">
                            <h3 class="card-title">Article
                            </h3>
                            <div class="card-tools col-sm-1">
                                <a href="{{ route('article.index') }}" class="btn btn-primary btn-block btn-sm"><i class="fas fa-list"></i> List</a>

                            </div>
                        </div>
                        <!-- /.card-header -->
                        @if (count($errors) > 0)
                        <div class="alert alert-danger">
                            <strong>Whoops!</strong> There were some problems with your input.<br><br>
                            <ul>
                                @foreach ($errors->all() as $error)
                                <li>{{ $error }}</li>
                                @endforeach
                            </ul>
                        </div>
                        @endif
                        <form class="form-horizontal" ​​​ action="{{ route('article.store') }}" method="POST" enctype="multipart/form-data">
                            @csrf
                            <div class="card-body pad">

                                <div class="form-group">
                                    <label for="exampleInputEmail1"> <i class="fas fa-book mr-1"></i> Title</label>
                                    <input type="text" class="form-control" name="title" id="exampleInputEmail1" required placeholder="Enter title">
                                </div>
                                <div class="form-group pull-left">
                                    <img src="{{ asset('img/thumbnail.jpg') }}" id="thumbnail-img-tag" class="img-thumbnail" alt="Thumbnail" style="width: 250px;height: 250px;">
                                    <input id="myInput" type="file" class=" form-control thumbnail-img" name="thumbnail" style="visibility:hidden" />
                                    <a href="#" class="btn btn-sm btn-primary" onclick="$('#myInput').click();"><i class="fas fa-file"></i> Thumbnail</a>
                                </div>
                                <div class="form-group">
                                    <label for="exampleInputEmail1">Short Description</label>
                                    <textarea class="form-control" cols="10" name="short_description"  required></textarea>
                                </div>
                                <div class="form-group">
                                    <label for="exampleInputEmail1">Content</label>
                                    <textarea class="textarea" cols="10" name="content" placeholder="Place some text here" required style="width: 100%; height: 500px; font-size: 14px; border: 1px solid rgb(221, 221, 221); display: none;"></textarea>
                                </div>
                                <div class="row">
                                    <div class="col-sm-3">
                                        <div class="form-group">
                                            <label>Type</label>
                                            <select class="form-control" name="articletype">
												@foreach ($articleTypes as $articleType)
													<option value="{{ $articleType->id}}">{{ $articleType->article_type }}</option>
												@endforeach
											</select>
                                        </div>
                                    </div>
                                    <div class="col-sm-3">
                                        <div class="form-group">
                                            <label>Date</label>
                                            <input type="text" name="date" class="form-control" id="date" value="{{ date('d-m-Y') }}" placeholder="dd/mm/yyyy" required>
                                        </div>
                                    </div>
                                    <div class="col-sm-3">
                                        <div class="form-group">
                                            <label>Time</label>
                                            <input type="text" name="time" class="form-control" id="time" value="{{ date('H:i A') }}" placeholder="hh:mm" required>
                                        </div>
                                    </div>
                                </div>

                            </div>
                            <!-- /.card-body -->
                            <div class="card-footer">
                                <button type="submit" class="btn btn-info btn-sm col-sm-1"><i class="fas fa-save"></i>  Save</button>
                                <button type="reset" class="btn btn-danger btn-sm col-sm-1"><i class="fas fa-trash-restore"></i>  Cancel</button>
                            </div>
                            <!-- /.card-footer -->
                        </form>
                        <!-- /.card-body -->
                    </div>
                    <!-- /.card -->
                </div>
                <!-- /.col -->
            </div>
            <!-- /.row -->
        </div>
    </section>
    <!-- /.content -->
</div>
<!-- /.content-wrapper -->

@endsection @section('js') 
<script type="text/javascript">
    function readURL(input) {
        if (input.files && input.files[0]) {
            var reader = new FileReader();
            
            reader.onload = function (e) {
                $('#thumbnail-img-tag').attr('src', e.target.result);
            }
            reader.readAsDataURL(input.files[0]);
        }
    }
    $(".thumbnail-img").change(function(){
        readURL(this);
    });
</script>
@endsection

resources/views/backend/articles/index.blade.php
@extends('layouts.backend') @section('content')

<!-- Content Wrapper. Contains page content -->
<div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
        <div class="container-fluid">
            <div class="row mb-2">
                <div class="col-sm-6">
                    <h1>Dashboard</h1>
                </div>
                <div class="col-sm-6">
                    <ol class="breadcrumb float-sm-right">
                        <li class="breadcrumb-item">
                            <a href="#">Home</a>
                        </li>
                        <li class="breadcrumb-item">
                            <a href="#">Articles</a>
                        </li>
                        <li class="breadcrumb-item active">Articles List</li>
                    </ol>
                </div>
            </div>
        </div>
        <!-- /.container-fluid -->
    </section>


    <!-- Main content -->
    <section class="content">
        {{-- --}}
        <div class="row">
            <div class="col-md-12">
                @if ($message = Session::get('success'))
                <div class="alert alert-success">
                    <p>{{ $message }}</p>
                </div>
                @endif
                <div class="card card-outline card-info">
                    <div class="card-header">
                        <h3 class="card-title">
                            Article
                            <small>List</small>
                        </h3>
                        <!-- tools box -->
                        <div class="card-tools">
                            <a href="{{ route('article.create') }}" class="btn btn-sm btn-primary">
                  <i class="fas fa-plus-circle"></i> Create New</a>
                        </div>
                        <!-- /. tools -->
                    </div>
                    <!-- /.card-header -->
                    <div class="card-body pad">
                        <table id="example1" class="table table-bordered table-striped dataTable">
                            <thead>
                                <tr>
                                    <th style="width: 5%;">No</th>
                                    <th>Article</th>
                                    <th style="width: 10%;">Thumbnail</th>
                                    <th style="width: 8%;">Post by</th>
                                    <th>Post date</th>
                                    <th style="width: 20%; height:10%">Action</th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach ($articles as $key => $article)
                                <tr>
                                    <td>{{ ++ $key}}</td>
                                    <td>{{ $article->title }}</td>
                                    <td><img src="{{ asset('storage/'.$article->thumbnail) }}" width="70" 
                                        height="70" alt="Thumbnail"></td>
                                    <td>{{ $article->postby }}</td>
                                    <td>{{ $article->date }} {{$article->time}}</td>
                                    <td>
                                        <div style="margin-bottom: 10px;">
                                            <form action="{{ url('article/status',$article->id) }}" method="post" style="display:inline">
                                                @csrf @if($article->active_status == 1)
                                                <input type="hidden" name="status" value="0">
                                                <button type="submit" class="btn btn-danger btn-sm"><i class="fas fa-toggle-off"></i> Deactivated</button> @else
                                                <input type="hidden" name="status" value="1">
                                                <button type="submit" class="btn btn-success btn-sm"><i class="fas fa-toggle-on"></i> Activated</button> @endif

                                            </form>
                                            <a href="{{ route('article.show',$article->id) }}" class="btn btn-primary btn-sm"><i class="fas fa-folder"></i> Show</a>
                                        </div>
                                        <a href="{{ route('article.edit',$article->id) }}" class="btn btn-warning btn-sm"><i class="fas fa-pencil-alt"></i> Edit</a>
                                        <form action="{{ route('article.destroy',[$article->id]) }}" method="post" style="display:inline">
                                            {{ csrf_field() }} {{ method_field('DELETE') }}
                                            <button type="submit" class="btn btn-danger btn-sm"><i class="fas fa-trash-restore"></i> Delete</button>
                                        </form>
                                    </td>
                                </tr>
                                @endforeach
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
            <!-- /.col-->
        </div>

    </section>
    <!-- /.content -->
</div>
<!-- /.content-wrapper -->

@endsection @section('js')
<script type="text/javascript">
    $(function () {
        $('#example1').DataTable({
            "paging": true,
            "lengthChange": true,
            "searching": true,
            "ordering": true,
            "info": true,
            "autoWidth": true,
            "fixedHeader": {
                "header": true,
                "headerOffset": $('#header').height()
            },
            "oLanguage": {
                "sSearch": "Filter results:"
            },
            "responsive": false,
            "select": true,
            "destroy": true,
        });
      });
</script>
@endsection

resources/views/backend/articles/show.blade.php
@extends('layouts.backend') @section('content')

<!-- Content Wrapper. Contains page content -->
<div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
        <div class="container-fluid">
            <div class="row mb-2">
                <div class="col-sm-6">
                    <h1>Dashboard</h1>
                </div>
                <div class="col-sm-6">
                    <ol class="breadcrumb float-sm-right">
                        <li class="breadcrumb-item">
                            <a href="#">Home</a>
                        </li>
                        <li class="breadcrumb-item">
                            <a href="{{ url('article') }}">Article</a>
                        </li>
                        <li class="breadcrumb-item active">Article Show</li>
                    </ol>
                </div>
            </div>
        </div>
        <!-- /.container-fluid -->
    </section>

    <!-- Main content -->

    <section class="content">
        <div class="container-fluid">
            <div class="row">
                <div class="col-12">
                    <div class="card card-outline card-info">
                        <div class="card-header">
                            <h3 class="card-title">
                                Article
                                <small></small>
                            </h3>
                            <!-- tools box -->
                            <div class="card-tools">
                                <a href="{{ route('article.index') }}" class="btn btn-primary btn-sm">
							  <i class="fas fa-list"></i> Article List</a>
                            </div>
                            <!-- /. tools -->
                        </div>
                        <!-- /.card-header -->
                        <div class="card-body pad">
                            @if (count($errors) > 0)
                            <div class="alert alert-danger">
                                <strong>Whoops!</strong> There were some problems with your input.<br><br>
                                <ul>
                                    @foreach ($errors->all() as $error)
                                    <li>{{ $error }}</li>
                                    @endforeach
                                </ul>
                            </div>
                            @endif
                        	<div class="form-group">
                                <label>Title</label>
                                <p>{{ $articles->title }}</p>
                            </div>
                            <div class="form-group">
                                <label>Type</label>
                                <p>{{ $articleTypes->article_type }}</p>
                            </div>
                            <div class="form-group">
                                <label>Thumbnail</label><br>
                                <img src="{{ asset('storage/'.$articles->thumbnail) }}" width="340" 
                                height="220" alt="Thumbnail">
                            </div>
                            <div class="form-group">
                                <label>Content</label>
                                <p>{!! $articles->content !!}</p>
							</div>
							<div class="form-group">
								<label>Post By</label>
								<p><i class="fas fa-clock"></i> {{ $articles->postby }}</p>
							</div>
							<div class="form-group">
								<label>Post Date</label>
								<p><i class="fas fa-calendar-week"></i> {{ $articles->date }}, {{ $articles->time }}</p>
							</div>
                            <!-- /.card-body -->
                        </div>
                        <!-- /.card -->
                    </div>
                    <!-- /.col -->
                </div>
                <!-- /.row -->
            </div>
    </section>
    <!-- /.content -->
    </div>
    <!-- /.content-wrapper -->

    @endsection @section('js') @endsection